%% Voltage plot
close all;
hold on;
for i=1:15
plot(0:11,voltage(i,:)*(V_base/10^3))
end
V_min(1:12)=400;
V_max(1:12)=420;
plot(0:11,V_min,'--k')
plot(0:11,V_max,'--k')
xlabel('timesteps');
ylabel('Voltage level [kV]');
axis([0 11 395 425])




%% Reactive power
figure;
hold on;

totalcap(1:12)=0;
totalreac(1:12)=0;

for i=1:16
   for j=1:12
       if qreactive(i,j)>0
           totalcap(j)=totalcap(j)+qreactive(i,j);
       elseif qreactive(i,j)<0
           totalreac(j)=totalreac(j)+abs(qreactive(i,j));
       end
   end
end

plot(0:11,totalcap,'g','Linewidth',1.5)
xlabel('timestep');
ylabel('Capacitors');
axis([0 11 0 15])


figure;

plot(0:11,totalreac,'r','Linewidth',1.5)
axis([0 11 0 15])

xlabel('timestep');
ylabel('Reactors');


%% Reactive switching
figure;
hold on;

plot(0:11,sum(abs(qswitch)),'m','Linewidth',1.5)
axis([0 11 0 15])
xlabel('timestep');
ylabel('Number of switchings');

%% Cost
figure;
hold on;

plot(0:11,cost,'k','Linewidth',1.5)
axis([0 11 0 1])
xlabel('timestep');
ylabel('cost');

%% Time
figure;
hold on;

plot(0:11,elapsed,'k','Linewidth',1.5)
axis([0 11 0 1500])
xlabel('timestep');
ylabel('seconds');

%% Reactive SVC power
% figure;
% hold on;
% 
% qsvcpos(1:12)=0;
% qsvcneg(1:12)=0;
% for j=1:12
%     for i=1:16
%         if qsvc(i,j)>0
%             qsvcpos(j)=qsvcpos(j)+qsvc(i,j);
%         elseif qsvc(i,j)<0
%             qsvcneg(j)=qsvcneg(j)+qsvc(i,j);
%         end
%     end
% end
% 
% 
% plot(0:11,qsvcneg,'r','Linewidth',1.5)
% plot(0:11,qsvcpos,'g','Linewidth',1.5)
% axis([0 11 -1.5 1.5])
% xlabel('timestep');
% ylabel('SVC reactive power generated [pu]');
% legend('Reactive power consumed','Reactive power generated');

%% Reactive on/off plot
figure;
hold on;
for i=1:16
plot(0:11,qreactive(i,:))
end
xlabel('timestep');
ylabel('Reactive on/off');
axis([0 11 -5 16])

