% Reads AMPL log files
clear;
close all;
totalruns=1;

V_base=410e3;
S_base=100e6;

% for run=1:100 %read all runs
for run=1:totalruns
% run=1;

runstring=num2str(run);
totaltime=12;

for time=1:totaltime;
timestring=num2str(time);
costlog=strcat('logg_cont_heavy2/run',runstring,'/cost',runstring,timestring,'.log');
fid=fopen(costlog);
cost(time+(totaltime*(run-1))) = fscanf(fid, '%f');
fclose(fid);

voltagelog=strcat('logg_cont_heavy2/run',runstring,'/voltage',runstring,timestring,'.log');
fid=fopen(voltagelog);
voltage(1:16,time+(totaltime*(run-1))) = fscanf(fid, '%f');
fclose(fid);

powerlog=strcat('logg_cont_heavy2/run',runstring,'/power',runstring,timestring,'.log');
fid=fopen(powerlog);
power(1:16,time+(totaltime*(run-1))) = fscanf(fid, '%f');
fclose(fid);

reactivelog=strcat('logg_cont_heavy2/run',runstring,'/reactive',runstring,timestring,'.log');
fid=fopen(reactivelog);
qreactive(1:16,time+(totaltime*(run-1))) = fscanf(fid, '%f');
fclose(fid);

switchlog=strcat('logg_cont_heavy2/run',runstring,'/switch',runstring,timestring,'.log');
fid=fopen(switchlog);
qswitch(1:16,time+(totaltime*(run-1))) = fscanf(fid, '%f');
fclose(fid);

svclog=strcat('logg_cont_heavy2/run',runstring,'/svc',runstring,timestring,'.log');
fid=fopen(svclog);
qsvc(1:16,time+(totaltime*(run-1))) = fscanf(fid, '%f');
fclose(fid);

prevlog=strcat('logg_cont_heavy2/run',runstring,'/prev',runstring,timestring,'.log');
fid=fopen(prevlog);
prev(1:16,time+(totaltime*(run-1))) = fscanf(fid, '%f');
fclose(fid);

timelog=strcat('logg_cont_heavy2/run',runstring,'/time',runstring,timestring,'.log');
fid=fopen(timelog);
elapsed(time+(totaltime*(run-1))) = fscanf(fid, '%f');
fclose(fid);

%log feasiblilty of the given optimization 1
feasiblelog=strcat('logg_cont_heavy2/run',runstring,'/asklog',runstring,timestring,'.log');
fid=fopen(feasiblelog);
feasible=fscanf(fid,'%s');
if 0==isempty(strfind(feasible, 'open_stackdumpfile'))
    status(time+(totaltime*(run-1)))=4; %4 means stackdump
elseif (0==isempty(strfind(feasible, 'bonmin:Infeasibleproblem'))) || (0==isempty(strfind(feasible, 'Partialsearch-bestobjective1e+50')))
    status(time+(totaltime*(run-1)))=1; %1 means infeasible
elseif 0==isempty(strfind(feasible, 'bonmin:Optimizationinteruptedonlimit.'))
    status(time+(totaltime*(run-1)))=2; %2 means interupted on time limit
elseif 0==isempty(strfind(feasible, 'bonmin:Optimal'))
    status(time+(totaltime*(run-1)))=3; %3 means optimal
end
    
fclose(fid);

  
    


end


end %end all runs