% Statistical analysis of the simulations, all infeasible solutions
% discarded

%init

close all;
casetime=0;

%% Feasibility statistics OK

infeasible=sum(status==1); %number of infeasible
interupted=sum(status==2); %number of interupted on limit
optimal=sum(status==3); %number of optimal
stackdump=sum(status==4); %number of stackdumps

bar(1:4,[infeasible interupted optimal stackdump],0.4,'k')
%title('Status')
statuslabel = ['Infeasible ';
'Interrupted';
'Optimal    ';
'Full memory'];
set(gca,'XTickLabel',statuslabel)
ylabel('Occurrences')
figure;



%find infeasible cases
runinfeasible(1:totalruns)=0;

for i=1:totalruns
    for j=1:12
        if status(totaltime*(i-1)+j)==1;
            runinfeasible(i)=1;
        end
    end
end
    
% stem(1:1,sum(runinfeasible))
% figure;
    
    
    
%% cost statistics OK

largecost=0;
mediumcost=0;
smallcost=0;
nocost=0;

for i=1:totalruns
    if runinfeasible(i)==0
        for j=1:totaltime
            if cost(totaltime*(i-1)+j)>10
                largecost = largecost+1; % totalcost(i)+
            elseif cost(totaltime*(i-1)+j)>1
                mediumcost=mediumcost+1;
            elseif cost(totaltime*(i-1)+j)>0.1
                smallcost=smallcost+1;
            else
                nocost=nocost+1;
            end
        end
    end
end

bar(1:4,[nocost smallcost mediumcost largecost],0.4,'k')
%title('Cost distribution')
statuslabel = ['No cost    ';
'Low cost   ';
'Medium cost';
'High cost  '];
set(gca,'XTickLabel',statuslabel)
ylabel('Occurrences')
figure;

maxcost=max(cost);
mincost=min(cost);

%% Time statisctics OK

averagetime=mean(elapsed);


maxtime=max(elapsed); %will probably go to the limit


fulltime(1:totalruns)=0;

for i=1:totalruns
     fulltime(i)=fulltime(i)+elapsed(totaltime*(i-1)+totaltime);
end

fulltime(find(runinfeasible))=[];

hist(fulltime/60,totalruns)
%title('Total time usage, minutes')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','k','EdgeColor','w')
xlabel('Minutes')
ylabel('Occurrences')
figure;




%% Voltage statistics OK

meanvoltage(1:(totalruns*15))=0;

for i=1:totalruns
    for k=1:15
         for j=1:totaltime
               meanvoltage(15*(i-1)+k)=meanvoltage(15*(i-1)+k)+voltage(k,totaltime*(i-1)+j); %
         end
         meanvoltage(15*(i-1)+k)=meanvoltage(15*(i-1)+k)/totaltime;
    end
end

for k=1:15
    meanvoltage((find(runinfeasible)-1)*15+1)=[];
end

voltagebreaches=sum(meanvoltage*V_base>420100) + sum(meanvoltage*V_base<399900);

hist((V_base/10^3)*meanvoltage,totalruns)
%title('Averagevoltage in each bus over 12 steps, not bus 16')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','b','EdgeColor','w')
xlabel('Voltage [kV]')
ylabel('Occurrences')
figure;

meanvoltage2(1:(totalruns*15))=0;

for k=1:15
    for i=1:totalruns
         for j=1:totaltime
               meanvoltage2(totalruns*totaltime*(k-1)+j+(i-1)*totaltime)=voltage(k,totaltime*(i-1)+j); %
         end
    end
end

% for k=1:15
%    meanvoltage2((find(runinfeasible)-1)*15+1)=[];
% end

voltagebreachesall=sum(meanvoltage2*V_base>420100) + sum(meanvoltage2*V_base<399900);

hist((V_base/10^3)*meanvoltage2,totalruns)
%title('Voltage in each bus over 1 step, not bus 16')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','b','EdgeColor','w')
xlabel('Voltage [kV]')
ylabel('Occurrences')
figure;



%% Power loss statistics OK

meanpower(1:(totalruns))=0;
sumpower=sum(power);
for i=1:totalruns
         for j=1:totaltime
               meanpower(i)=meanpower(i)+sumpower(totaltime*(i-1)+j);
         end
end

    meanpower=meanpower/totaltime;

for k=1:16
    meanpower((find(runinfeasible)))=[];
end



hist((S_base*(10^-6))*meanpower,totalruns)
% title('Power loss, per case [MW]')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','k','EdgeColor','w')
xlabel('Power loss [MW]')
ylabel('Occurrences')
figure;

maxpower=S_base*max(meanpower);
minpower=S_base*min(meanpower);







%% Capacitors and reactors OK

totalcapacitor(1:totalruns)=0;
for i=1:totalruns
    for j=1:totaltime
        for k=1:16 %all nodes
            if qreactive(k,(j+(i-1)*totaltime))>0
                totalcapacitor(i) = totalcapacitor(i)+qreactive(k,(j+(i-1)*totaltime));
            end
        end
    end
end

totalcapacitor(find(runinfeasible))=[];

hist(totalcapacitor/totaltime,totalruns)
% title('Total capacitors in')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','g','EdgeColor','w')
xlabel('Capacitors')
ylabel('Occurrences')
figure;

totalreactor(1:totalruns)=0;
for i=1:totalruns
    for j=1:totaltime
        for k=1:16 %all nodes
            if qreactive(k,(j+(i-1)*totaltime))<0
                totalreactor(i) = totalreactor(i)+abs(qreactive(k,(j+(i-1)*totaltime)));
            end
        end
    end
end

totalreactor(find(runinfeasible))=[];

hist(totalreactor/totaltime,totalruns)
% title('Total reactor in')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','r','EdgeColor','w')
xlabel('Reactors')
ylabel('Occurrences')
figure;

maxreactive=max(qreactive);

for i=1:(totalruns*totaltime)
    if maxreactive(i)<0
        maxreactive(i)=0;
    end
end

hist(maxreactive,max(maxreactive)+1)
h = findobj(gca,'Type','patch');
set(h,'FaceColor','g','EdgeColor','w')
set(gca,'XTick',0:1:max(maxreactive))
xlabel('Capacitors')
ylabel('Occurrences')
figure;

minreactive=min(qreactive);

for i=1:(totalruns*totaltime)
    if minreactive(i)>0
        minreactive(i)=0;
    end
end

minreactive=abs(minreactive);

hist(minreactive,max(minreactive)+1)
h = findobj(gca,'Type','patch');
set(h,'FaceColor','r','EdgeColor','w')
set(gca,'XTick',0:1:max(minreactive))
xlabel('Reactors')
ylabel('Occurrences')
figure;

% competing components

% [C,I]=sort(totalcapacitor);
% R=totalreactor(I);
% stem(C,R,'k')
% title('capacitors vs. reactors - competing components');
% figure;

%% Switching statistics NOT OK

totalswitching(1:totalruns)=0;
for i=1:totalruns
    for j=1:totaltime
        if j~=1
            for k=1:16
                    totalswitching(i) = totalswitching(i)+abs(qswitch(k,j+(i-1)*totaltime));
            end
        end
    end
end

totalswitching(find(runinfeasible))=[];


hist(totalswitching/(totaltime-1),totalruns)
% title('totalswitching')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','m','EdgeColor','w')
xlabel('Switches')
ylabel('Occurrences')
figure;

%% SVC statistics

% totalsvc(1:totalruns)=0;
% for i=1:totalruns
%     for j=1:totaltime
%         for k=1:16
%                 totalsvc(i) = totalsvc(i)+abs(qsvc(k,j+(i-1)*totaltime));
%         end
%     end
% end
% 
% 
% totalsvc(find(runinfeasible))=[];
% averagesvc=totalsvc/totaltime;


% hist(averagesvc,totalruns)
% title('Average total SVC usage')
% h = findobj(gca,'Type','patch');
% set(h,'FaceColor','k','EdgeColor','w')
% figure;


% 

possvc(1:totalruns)=0;
negsvc(1:totalruns)=0;
for i=1:totalruns
    for j=1:totaltime
        for k=1:16
            if qsvc(k,j+(i-1)*totaltime)>0
                possvc(i) = possvc(i)+abs(qsvc(k,j+(i-1)*totaltime));
            elseif qsvc(k,j+(i-1)*totaltime)<0
                negsvc(i) = negsvc(i)+abs(qsvc(k,j+(i-1)*totaltime));
            end
        end
    end
end

possvc=possvc/totaltime;
negsvc=negsvc/totaltime;

hist(possvc,totalruns)
% title('SVC reactive power production')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','g','EdgeColor','w')
xlabel('SVC reactive power generation [pu]')
ylabel('Occurrences')
figure;

hist(negsvc,totalruns)
% title('SVC reactive power consumption')
h = findobj(gca,'Type','patch');
set(h,'FaceColor','r','EdgeColor','w')
xlabel('SVC reactive power consumption [pu]')
ylabel('Occurrences')
figure;

%% nodal analysis
% for i=1:16
% hist(qreactive(i,:))%*(V_base/1000))
% figure;
% end
ispos(1:1200)=0;
isneg(1:1200)=0;
teller=0;
for i = 1:totalruns
    for j=1:totaltime
        for k=1:16
            if qreactive(k,(i-1)*totaltime+j)>0
                ispos((i-1)*totaltime+j)=1;
            elseif qreactive(k,(i-1)*totaltime+j)<0
                isneg((i-1)*totaltime+j)=1;
            end  
        end
        if (ispos((i-1)*totaltime+j)==isneg((i-1)*totaltime+j)) && (ispos((i-1)*totaltime+j)==1)
                teller=teller+1;
        end
    end
end



